/** @file sys_main.c 
*   @brief Application main file
*   @date 11-Dec-2018
*   @version 04.07.01
*
*   This file contains an empty main function,
*   which can be used for the application.
*/

/* 
* Copyright (C) 2009-2018 Texas Instruments Incorporated - www.ti.com 
* 
* 
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions 
*  are met:
*
*    Redistributions of source code must retain the above copyright 
*    notice, this list of conditions and the following disclaimer.
*
*    Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the 
*    documentation and/or other materials provided with the   
*    distribution.
*
*    Neither the name of Texas Instruments Incorporated nor the names of
*    its contributors may be used to endorse or promote products derived
*    from this software without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
*  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
*  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
*  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
*  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/


/* USER CODE BEGIN (0) */
#include "system.h"
#include "sci.h"
#include "sys_core.h"
#include "reg_sci.h"
#include "lin.h"
#include "sys_dma.h"
#include <stdio.h>
#include <string.h>
/* USER CODE END */

/* Include Files */

#include "sys_common.h"

/* USER CODE BEGIN (1) */
#define DataSize 36
#define MBUFFDataSize 2
uint8 ucEventData[DataSize];
g_dmaCTRL g_dmaCTRLPKT,g_dmaCTRLPKT1;
uint32 DMA_Flag;
uint8 ucGo = 2;
/* USER CODE END */

/** @fn void main(void)
*   @brief Application main function
*   @note This function is empty by default.
*
*   This function is called after startup.
*   The user can use this function to implement the application.
*/

/* USER CODE BEGIN (2) */
void scidmaInit(sciBASE_t *sci);
void scidmaSend(uint8 *source_address);
void scienableMBUFF();
void scidisableMBUFF();
void TX_Data();
/* USER CODE END */

int main(void)
{
/* USER CODE BEGIN (3) */
    sciInit();
    TX_Data();
    _enable_interrupt_();
    scidmaInit(scilinREG);
/*
    scidmaSend(ucEventData);
    while(DMA_Flag != 0xAAAADDDD);

    scienableMBUFF();
    scidmaSend(ucEventData);
    while(DMA_Flag != 0xAAAADDDD);
    scidisableMBUFF();
*/
    while(1)
    {
        if(ucGo == 1)
        {
            ucGo = 0;
            scidisableMBUFF();
            scidmaSend(ucEventData);
            while(DMA_Flag != 0xAAAADDDD);
        }
        else if(ucGo == 2)
        {
            ucGo = 0;
            scienableMBUFF();
            scidmaSend(&ucEventData);
            while(DMA_Flag != 0xAAAADDDD);
        }
    }
/* USER CODE END */
}


/* USER CODE BEGIN (4) */
void TX_Data()
{
    uint32 i = 0;
    uint8  j = 0;
    for( i = 0, j = 0x30; i < DataSize; i++)
    {
        ucEventData[i] = j;
        j++;
    }
}

void scidmaInit(sciBASE_t *sci)
{
    dmaEnable();

    dmaEnableInterrupt(DMA_CH0, BTC);

    dmaEnableInterrupt(DMA_CH1, BTC);

    dmaReqAssign(DMA_CH0,29);

    dmaReqAssign(DMA_CH1,29);

    g_dmaCTRLPKT.CHCTRL    = 0;
    g_dmaCTRLPKT.ELCNT     = 1;
    g_dmaCTRLPKT.ELDOFFSET = 0;
    g_dmaCTRLPKT.ELSOFFSET = 0;
    g_dmaCTRLPKT.FRDOFFSET = 0;
    g_dmaCTRLPKT.FRSOFFSET = 8;
    g_dmaCTRLPKT.PORTASGN  = 4;
    g_dmaCTRLPKT.TTYPE     = FRAME_TRANSFER ;
    g_dmaCTRLPKT.ADDMODERD = ADDR_OFFSET;
    g_dmaCTRLPKT.ADDMODEWR = ADDR_FIXED;
    g_dmaCTRLPKT.AUTOINIT  = AUTOINIT_OFF;

    g_dmaCTRLPKT1.CHCTRL    = 0;
    g_dmaCTRLPKT1.ELCNT     = 1;
    g_dmaCTRLPKT1.ELDOFFSET = 0;
    g_dmaCTRLPKT1.ELSOFFSET = 0;
    g_dmaCTRLPKT1.FRDOFFSET = 0;
    g_dmaCTRLPKT1.FRSOFFSET = 8;
    g_dmaCTRLPKT1.PORTASGN  = 4;
    g_dmaCTRLPKT1.TTYPE     = FRAME_TRANSFER ;
    g_dmaCTRLPKT1.ADDMODERD = ADDR_OFFSET;
    g_dmaCTRLPKT1.ADDMODEWR = ADDR_FIXED;
    g_dmaCTRLPKT1.AUTOINIT  = AUTOINIT_OFF;

    DMA_Flag = 0xAAAADDDD;
}

void scidmaSend(uint8 *source_address)
{
    while(DMA_Flag != 0xAAAADDDD);

    DMA_Flag = ~0xAAAADDDD;

    g_dmaCTRLPKT.SADD   = (uint32)source_address;

    g_dmaCTRLPKT1.SADD   = (uint32)(source_address+4);

    if (((scilinREG->GCR1 >> 10) & 1) == 1)
    {
        g_dmaCTRLPKT.DADD      = (uint32)(&(linREG->TDx));
        g_dmaCTRLPKT.RDSIZE    = ACCESS_32_BIT;
        g_dmaCTRLPKT.WRSIZE    = ACCESS_32_BIT;
        g_dmaCTRLPKT.FRCNT     = MBUFFDataSize;

        g_dmaCTRLPKT1.DADD      = (uint32)(&(linREG->TDx[4]));
        g_dmaCTRLPKT1.RDSIZE    = ACCESS_32_BIT;
        g_dmaCTRLPKT1.WRSIZE    = ACCESS_32_BIT;
        g_dmaCTRLPKT1.FRCNT     = MBUFFDataSize;
    }
    else
    {
        g_dmaCTRLPKT.DADD   = (uint32)(&(scilinREG->TD));
        g_dmaCTRLPKT.RDSIZE = ACCESS_8_BIT;
        g_dmaCTRLPKT.WRSIZE = ACCESS_8_BIT;
        g_dmaCTRLPKT.FRCNT  = DataSize;
    }

    dmaSetCtrlPacket(DMA_CH0,g_dmaCTRLPKT);
    dmaSetCtrlPacket(DMA_CH1,g_dmaCTRLPKT1);

    dmaSetChEnable(DMA_CH0, DMA_HW);
    dmaSetChEnable(DMA_CH1, DMA_HW);

    scilinREG->SETINT = (1 << 16);
}

void scienableMBUFF()
{
    scilinREG->GCR1 |= (uint32)((uint32)1 << 10);

    scilinREG->FORMAT = (uint32)((uint32)7 << 0) | (uint32)((uint32)7 << 16);
}

void scidisableMBUFF()
{
    scilinREG->GCR1 &= ~(uint32)((uint32)1 << 10);

    scilinREG->FORMAT = (uint32)((uint32)7 << 0) | (uint32)((uint32)7 << 16);

}

/* USER CODE END */
